using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace SpriteSplit
{
  public class Game1 : Microsoft.Xna.Framework.Game
  {
    GraphicsDeviceManager graphics;
    SpriteBatch spriteBatch;
    Texture2D face;
    SpriteExploder exploder;

    public Game1()
    {
      graphics = new GraphicsDeviceManager(this);
      Content.RootDirectory = "Content";
    }

    protected override void Initialize()
    {
      base.Initialize();
    }

    protected override void LoadContent()
    {
      // create a new SpriteBatch, which can be used to draw textures.
      spriteBatch = new SpriteBatch(GraphicsDevice);

      face = Content.Load<Texture2D>("face");
      exploder = new SpriteExploder(new Vector2(392, 260), face.Width, face.Height, 4, 4);
    }

    protected override void UnloadContent()
    {
    }

    protected override void Update(GameTime gameTime)
    {
      // Allows the game to exit
      if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
        this.Exit();

      if (Keyboard.GetState().IsKeyDown(Keys.Escape))
        this.Exit();


      // update the sprite exploder after 3 seconds have passed
      if (gameTime.TotalGameTime.Seconds >= 3.0f)
        exploder.Update(gameTime);


      base.Update(gameTime);
    }

    protected override void Draw(GameTime gameTime)
    {
      GraphicsDevice.Clear(Color.Black);

      spriteBatch.Begin();

      // draw the entire sprite
      spriteBatch.Draw(face, new Vector2(100, 100), Color.White);

      // draw parts of the sprite
      int xInc = 8;
      int yInc = 8;
      float spacing = 1.5f;

      // draw parts of the sprite
      for (int x = 0; x < face.Width; x += xInc)
        for (int y = 0; y < face.Height; y += yInc)
        {
          Vector2 position = new Vector2(100 + x * spacing, 150 + y * spacing);
          Rectangle source = new Rectangle(x, y, xInc, yInc);
          spriteBatch.Draw(face, position, source, Color.White);
        }


      // draw the sprite with the SpriteExploder component
      exploder.Draw(gameTime, spriteBatch, face);

      spriteBatch.End();


      base.Draw(gameTime);
    }
  }
}
